<?php
  /*  Poster - Simple and light weight blog engine
   *  Copyright (C) 2004-2009  Andrea Bolognani <eof@kiyuko.org>
   *
   *  This program is free software; you can redistribute it and/or modify
   *  it under the terms of the GNU General Public License as published by
   *  the Free Software Foundation; either version 2 of the License, or
   *  (at your option) any later version.
   *
   *  This program is distributed in the hope that it will be useful,
   *  but WITHOUT ANY WARRANTY; without even the implied warranty of
   *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   *  GNU General Public License for more details.
   *
   *  You should have received a copy of the GNU General Public License along
   *  with this program; if not, write to the Free Software Foundation, Inc.,
   *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
   *
   *  Homepage: http://kiyuko.org/software/poster
   */

  $ModuleName = 'Login';
  $BlogRoot = '../';
  $TemplateDir = 'admin/template/';
  $PosterVersion = '1.0.12';
  
  ob_start ();

  /* Include config file and functions */
  require ($BlogRoot . 'config.php');
  require ($BlogRoot . 'include/poster.php');

  /* Disable error messages if debug is turned off in the config file;
   * otherwise, show all error and warning messages */
  error_reporting (NULL);
  if ($Debug == 1) {
    error_reporting (E_ALL);
  }

  /* Read users */
  $Users = ReadUsers ();

  /* If the user has a cookie, restart his session */
  if ((isset ($_COOKIE['Poster'])) && ($_COOKIE['Poster'])) {
    session_name ('Poster');
    session_start ();
  }

  /* Get some info about the user */
  list ($UserLogin, $UserName, $UserLink, $UserPerms) = UserInfo ();

  /* The user is not logged in, or the authentication token is invalid */
  if (!isset ($UserLogin)) {

    /* The user is submitting the login form */
    if ((isset ($_POST['login'])) && (isset ($_POST['password']))) {

      /* Get the submitted login and password */
      $Login = stripslashes ($_POST['login']);
      $Password = md5 (stripslashes ($_POST['password']));

      /* Check the user exists */
      if (isset ($Users[$Login])) {

        /* Create a new session */
        session_name ('Poster');
        session_start ();

        /* Store authentication info into the session */
        $_SESSION[$BlogUrl] = array ('login' => $Login,
                                     'password' => $Password,
                                     'perms' => $Users[$Login]['perms']);

        /* Make sure the session data is saved */
        session_write_close ();

        /* Save the session id on a cookie for later use  */
        setcookie ('Poster', session_id (), time () + (60 * 60 * 24 * 7), '/');
      }

      /* Redirect the user */
      header ('Location: show.php');
    }

    /* Show the login form */
    else {

      /* Show header */
      ob_start ();
      include ($BlogRoot . $TemplateDir . 'header.php');
      $Header = ob_get_contents ();
      ob_end_clean ();
      echo TagsReplace ($Header, NULL);

      echo '<form method="post" action="index.php">
    <div style="text-align: center">
        <table style="display: inline; text-align: left; border: 0px">
            <tr>
                <td style="width: 30%">
                    <label for="login">Login</label>
                </td>
                <td style="width: 70%">
                    <input type="text" id="login" name="login" />
                </td>
            </tr>
            <tr>
                <td style="width: 30%">
                    <label for="password">Password</label>
                </td>
                <td style="width: 70%">
                    <input type="password" id="password" name="password" />
                </td>
            </tr>
            <tr>
                <td style="width: 30%">
                    <input type="submit" value="Login" />
                </td>
                <td style="width: 70%">
                    &nbsp;
                </td>
            </tr>
        </table>
    </div>
</form>' . "\n";

      /* Show footer */
      ob_start ();
      include ($BlogRoot.$TemplateDir.'footer.php');
      $Footer = ob_get_contents ();
      ob_end_clean ();
      echo TagsReplace ($Footer, NULL);
    }
  }

  /* If the user is logged in, redirect him */
  else {
    header ('Location: show.php');
  }

  ob_end_flush ();
?>
