<?php
  /*  Poster - Simple and light weight blog engine
   *  Copyright (C) 2004-2009  Andrea Bolognani <eof@kiyuko.org>
   *
   *  This program is free software; you can redistribute it and/or modify
   *  it under the terms of the GNU General Public License as published by
   *  the Free Software Foundation; either version 2 of the License, or
   *  (at your option) any later version.
   *
   *  This program is distributed in the hope that it will be useful,
   *  but WITHOUT ANY WARRANTY; without even the implied warranty of
   *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   *  GNU General Public License for more details.
   *
   *  You should have received a copy of the GNU General Public License along
   *  with this program; if not, write to the Free Software Foundation, Inc.,
   *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
   *
   *  Homepage: http://kiyuko.org/software/poster
   */

  $PosterVersion = '1.0.12';

  /* Tell the user agent to treat this file as XML */
  header ('Content-Type: application/rss+xml');
  error_reporting (NULL);
  
  /* Set root dir, then include config file and functions */
  $BlogRoot = '../';
  $TemplateDir = 'feed/rss/';
  require ($BlogRoot . 'config.php');
  require ($BlogRoot . 'include/poster.php');
  
  /* Read users, categories, and posts */
  $Users = ReadUsers ();
  $Categories = ReadCategories ();
  $Posts = ReadPosts ();
  RemoveFuturePosts ();

  /* Get the post list */
  $Context = GetContext ();
  $Query = GetQuery ($Context);
  $PostsList = GetPostsList ($Context, $Query);
  
  /* Show header */
  ob_start ();
  include ($BlogRoot . $TemplateDir . 'header.php');
  $Header = ob_get_contents ();
  ob_end_clean ();
  echo TagsReplace ($Header, NULL);
  
  /* Show posts */
  foreach ($PostsList as $PostId) {
    ShowPost ($PostId);
  }

  /* Show footer */
  ob_start ();
  include ($BlogRoot . $TemplateDir . 'footer.php');
  $Footer = ob_get_contents ();
  ob_end_clean ();
  echo TagsReplace ($Footer, NULL);
?>
