<?php
  /*  Poster - Simple and light weight blog engine
   *  Copyright (C) 2004-2009  Andrea Bolognani <eof@kiyuko.org>
   *
   *  This program is free software; you can redistribute it and/or modify
   *  it under the terms of the GNU General Public License as published by
   *  the Free Software Foundation; either version 2 of the License, or
   *  (at your option) any later version.
   *
   *  This program is distributed in the hope that it will be useful,
   *  but WITHOUT ANY WARRANTY; without even the implied warranty of
   *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   *  GNU General Public License for more details.
   *
   *  You should have received a copy of the GNU General Public License along
   *  with this program; if not, write to the Free Software Foundation, Inc.,
   *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
   *
   *  Homepage: http://kiyuko.org/software/poster
   */

  function BlogArchive ()
  {
    global $BlogRoot, $BlogUrl, $DataDir, $TemplateDir, $Posts;

    $BlogArchive = '';

    /* Check there is at least one post */
    if (count ($Posts) > 0) {

      /* Take the first 6 characters from the post's timestamp -- that is,
       * year and month */
      $Previous = '';
      $Current = substr ($Posts[0], 0, 6);
      $ArchivePostsNumber = 1;

      $i = 1;
      while (isset ($Posts[$i])) {

        /* Update previous and current post */
        $Previous = $Current;
        $Current = substr ($Posts[$i], 0, 6);

        /* If the year and the month are the same, increase the posts count */
        if (!strcmp ($Previous, $Current)) {
          $ArchivePostsNumber++;
        }

        /* If the month is different, show the previous month and go on with
         * the current one */
        else {

          /* Get the year and the month */
          $ArchiveYear = substr ($Previous, 0, 4);
          $ArchiveMonth = substr ($Previous, 4, 2);

          /* Create the permalink */
          $ArchivePermalink = CreateBlogLink ('archive=' . $Previous);

          /* Create the array used for tags replacing */
          $V = array ('a.year' => $ArchiveYear,
                      'a.month' => $ArchiveMonth,
                      'a.plink' => $ArchivePermalink,
                      'a.p_num' => $ArchivePostsNumber);

          /* Show the archive */
          ob_start ();
          include ($BlogRoot . $TemplateDir . 'archive.php');
          $Archive = ob_get_contents ();
          ob_end_clean ();
          $BlogArchive .= TagsReplace ($Archive, $V);

          /* Show a spacer */
          ob_start ();
          include ($BlogRoot . $TemplateDir . 'archive-archive_spacer.php');
          $Spacer = ob_get_contents ();
          ob_end_clean ();
          $BlogArchive .= TagsReplace ($Spacer, NULL);

          /* Reset posts number */
          $ArchivePostsNumber = 1;
        }

        $i++;
      }

      /* Show the last one */
      if ($Current) {

        /* Get the year and the month */
        $ArchiveYear = substr ($Current, 0, 4);
        $ArchiveMonth = substr ($Current, 4, 2);

        /* Create the permalink */
        $ArchivePermalink = CreateBlogLink ('archive=' . $Current);

        /* Create the array used for tags replacing */
        $V = array ('a.year' => $ArchiveYear,
                    'a.month' => $ArchiveMonth,
                    'a.plink' => $ArchivePermalink,
                    'a.p_num' => $ArchivePostsNumber);

        /* Show the archive */
        ob_start ();
        include ($BlogRoot . $TemplateDir . 'archive.php');
        $Archive = ob_get_contents ();
        ob_end_clean ();
        $BlogArchive .= TagsReplace ($Archive, $V);
      }
    }

    return $BlogArchive;
  }
?>
