<?php
  /*  Poster - Simple and light weight blog engine
   *  Copyright (C) 2004-2009  Andrea Bolognani <eof@kiyuko.org>
   *
   *  This program is free software; you can redistribute it and/or modify
   *  it under the terms of the GNU General Public License as published by
   *  the Free Software Foundation; either version 2 of the License, or
   *  (at your option) any later version.
   *
   *  This program is distributed in the hope that it will be useful,
   *  but WITHOUT ANY WARRANTY; without even the implied warranty of
   *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   *  GNU General Public License for more details.
   *
   *  You should have received a copy of the GNU General Public License along
   *  with this program; if not, write to the Free Software Foundation, Inc.,
   *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
   *
   *  Homepage: http://kiyuko.org/software/poster
   */

  function BlogAuthors ()
  {
    global $BlogRoot, $BlogUrl, $TemplateDir, $Users, $NullUsers;

    $BlogAuthors = '';

    /* Get a copy of the users, and sort them alphabetically */
    $CopyOfUsers = $Users;
    sort ($CopyOfUsers);

    for ($i = 0; $i < count ($CopyOfUsers); $i++) {

      /* Get the current user and some info about him */
      $User = $CopyOfUsers[$i];
      $AuthorName = $User['name'];
      $AuthorLink = $User['link'];

      /* Create the permalink for this user */
      $AuthorPermalink = CreateBlogLink ('author=' . $User['login']);

      /* Get the list of all the posts written by this user ando count them */
      $PostsList = GetPostsList ('author', $User['login']);
      $AuthorPostsNumber = count ($PostsList);

      /* Don't show the users who never wrote a post */
      if ($AuthorPostsNumber > 0) {

        $V = array ('a.name' => $AuthorName,
                    'a.link' => $AuthorLink,
                    'a.plink' => $AuthorPermalink,
                    'a.p_num' => $AuthorPostsNumber);

        /* Show the author */
        ob_start ();
        include ($BlogRoot . $TemplateDir . 'author.php');
        $Author = ob_get_contents ();
        ob_end_clean (); 
        $BlogAuthors .= TagsReplace ($Author, $V);

        /* If there are more authors, show a spacer */
        if ($i < (count ($CopyOfUsers) - 1)) {
          ob_start ();
          include ($BlogRoot . $TemplateDir . 'author-author_spacer.php');
          $Spacer = ob_get_contents ();
          ob_end_clean ();
          $BlogAuthors .= TagsReplace ($Spacer, NULL);
        }
      }
    }

    return $BlogAuthors;
  }
?>
