<?php
  /*  Poster - Simple and light weight blog engine
   *  Copyright (C) 2004-2009  Andrea Bolognani <eof@kiyuko.org>
   *
   *  This program is free software; you can redistribute it and/or modify
   *  it under the terms of the GNU General Public License as published by
   *  the Free Software Foundation; either version 2 of the License, or
   *  (at your option) any later version.
   *
   *  This program is distributed in the hope that it will be useful,
   *  but WITHOUT ANY WARRANTY; without even the implied warranty of
   *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   *  GNU General Public License for more details.
   *
   *  You should have received a copy of the GNU General Public License along
   *  with this program; if not, write to the Free Software Foundation, Inc.,
   *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
   *
   *  Homepage: http://kiyuko.org/software/poster
   */

  function BlogCategories ()
  {
    global $BlogRoot, $BlogUrl, $TemplateDir, $Categories;

    $BlogCategories = '';

    /* Get a copy of the categories, and sort them alphabetically */
    $CopyOfCategories = $Categories;
    sort ($CopyOfCategories);

    for ($i = 0; $i < count ($CopyOfCategories); $i++) {

      /* Get the current category and some info about it*/
      $Category = $CopyOfCategories[$i];
      $CategoryName = $Category['long'];

      /* Create the permalink for this category */
      $CategoryPermalink = CreateBlogLink ('category=' . $Category['short']);

      /* Get the list of all the posts in this category and count them */
      $PostsList = GetPostsList ('category', $Category['short']);
      $CategoryPostsNumber = count ($PostsList);

      /* Check the category has some posts in it; otherwise, skip it */
      if ($CategoryPostsNumber > 0) {

        /* Create the array used for tags replacing */
        $V = array ('c.name' => $Category['long'],
                    'c.plink' => $CategoryPermalink,
                    'c.p_num' => $CategoryPostsNumber);

        /* Show the category */
        ob_start ();
        include ($BlogRoot . $TemplateDir . 'category.php');
        $Category = ob_get_contents ();
        ob_end_clean ();
        $BlogCategories .= TagsReplace ($Category, $V);

        /* If there are more categories, show a spacer */
        if ($i < (count ($CopyOfCategories) - 1)) {
          ob_start ();
          include ($BlogRoot . $TemplateDir . 'category-category_spacer.php');
          $Spacer = ob_get_contents ();
          ob_end_clean ();
          $BlogCategories .= TagsReplace ($Spacer, $V);
        }
      }
    }

    return $BlogCategories;
  }
?>
