<?php
  /*  Poster - Simple and light weight blog engine
   *  Copyright (C) 2004-2009  Andrea Bolognani <eof@kiyuko.org>
   *
   *  This program is free software; you can redistribute it and/or modify
   *  it under the terms of the GNU General Public License as published by
   *  the Free Software Foundation; either version 2 of the License, or
   *  (at your option) any later version.
   *
   *  This program is distributed in the hope that it will be useful,
   *  but WITHOUT ANY WARRANTY; without even the implied warranty of
   *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   *  GNU General Public License for more details.
   *
   *  You should have received a copy of the GNU General Public License along
   *  with this program; if not, write to the Free Software Foundation, Inc.,
   *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
   *
   *  Homepage: http://kiyuko.org/software/poster
   */

  function CaptchaImage ($Word)
  {
    global $CaptchaBackgroundColor, $CaptchaTextColor, $CaptchaSpiralColor,
           $CaptchaOutlineColor;

    /* Create an empty image */
    $Image = ImageCreate (280, 115);

    /* Allocate colors for background, text and spirals */
    $BgColor = CaptchaColorAllocate ($Image, $CaptchaBackgroundColor);
    $TextColor = CaptchaColorAllocate ($Image, $CaptchaTextColor);
    $SpiralColor = CaptchaColorAllocate ($Image, $CaptchaSpiralColor);
    $OutlineColor = CaptchaColorAllocate ($Image, $CaptchaOutlineColor);

    /* Fill the image with the background color */
    ImageFilledRectangle ($Image, 0, 0, 280, 115, $BgColor);

    /* Draw a random spiral on the image */
    $X = mt_rand (0, 200);
    $Y = mt_rand (0, 115);
    CaptchaCreateSpiral ($Image, $X, $Y, $SpiralColor);

    /* Draw another random spiral on the image */
    $X = mt_rand (0, 280);
    $Y = mt_rand (0, 115);
    CaptchaCreateSpiral ($Image, $X, $Y, $SpiralColor);

    /* Choose a random size for the text */
    $Size = mt_rand (24, 30);

    /* Choose a random angle */
    $Angle = mt_rand (-25, 25);

    /* Get a random Y based on the angle */
    $X = mt_rand (10, 100);
    if ($Angle >= 0) {
      $Y = mt_rand (50, 100);
    }
    else { 
      $Y = mt_rand (25, 50);
    }

    /* Draw the text on the image */
    putenv ('GDFONTPATH=' . realpath ('.'));
    ImageTtfText ($Image, $Size, $Angle, $X, $Y, $TextColor, 'Font.ttf', $Word);

    /* Outline the image */
    ImageLine ($Image, 0, 0, 279, 0, $OutlineColor);
    ImageLine ($Image, 0, 0, 0, 114, $OutlineColor);
    ImageLine ($Image, 0, 114, 280, 114, $OutlineColor);
    ImageLine ($Image, 279, 0, 279, 114, $OutlineColor);

    /* Convert the image to JPEG and output it */
    ImageJpeg ($Image);
  }
?>
