<?php
  /*  Poster - Simple and light weight blog engine
   *  Copyright (C) 2004-2009  Andrea Bolognani <eof@kiyuko.org>
   *
   *  This program is free software; you can redistribute it and/or modify
   *  it under the terms of the GNU General Public License as published by
   *  the Free Software Foundation; either version 2 of the License, or
   *  (at your option) any later version.
   *
   *  This program is distributed in the hope that it will be useful,
   *  but WITHOUT ANY WARRANTY; without even the implied warranty of
   *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   *  GNU General Public License for more details.
   *
   *  You should have received a copy of the GNU General Public License along
   *  with this program; if not, write to the Free Software Foundation, Inc.,
   *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
   *
   *  Homepage: http://kiyuko.org/software/poster
   */

  function IsPost ($Item)
  {
    global $BlogRoot, $DataDir, $UserLogin;

    $Result = TRUE;

    /* Exclude special files */
    if ((!strcmp ($Item, '.')) || (!strcmp ($Item, '..'))) {
      $Result = FALSE;
    }

    /* Exclude non-dirs */
    if (!is_dir ($BlogRoot . $DataDir . $Item)) {
      $Result = FALSE;
    }

    /* Exclude non-existing posts */
    if (!file_exists ($BlogRoot . $DataDir . $Item . '/post')) {
      $Result = FALSE;
    }

    /* Exclude files whose name is not a number with length 14 */
    if ((strlen ($Item) != 14) || (!IsNumber ($Item))) {
      $Result = FALSE;
    }

    /* Check if the post is in the future */
    $Now = strtotime (TimeOffsetString (), time ());
    if ($Item > strftime ('%Y%m%d%H%M%S', $Now)) {

      /* FIXME This check should probably be moved somewhere else */
      /* Parse the post, and exclude it if the author is not the currently
       * logged-in user */
      $Post = ParsePost ($Item);
      if (strcmp ($Post['author'], $UserLogin) != 0) {
        $Result = FALSE;
      }
    }

    return $Result;
  }
?>
