<?php
  /*  Poster - Simple and light weight blog engine
   *  Copyright (C) 2004-2009  Andrea Bolognani <eof@kiyuko.org>
   *
   *  This program is free software; you can redistribute it and/or modify
   *  it under the terms of the GNU General Public License as published by
   *  the Free Software Foundation; either version 2 of the License, or
   *  (at your option) any later version.
   *
   *  This program is distributed in the hope that it will be useful,
   *  but WITHOUT ANY WARRANTY; without even the implied warranty of
   *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   *  GNU General Public License for more details.
   *
   *  You should have received a copy of the GNU General Public License along
   *  with this program; if not, write to the Free Software Foundation, Inc.,
   *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
   *
   *  Homepage: http://kiyuko.org/software/poster
   */

  function LockedFileWrite ($Filename, $Content)
  {
    $Check = TRUE;

    /* Try to open the file in read/write mode */
    $Handle = @fopen ($Filename, 'a+');

    /* Check the file was opened correctly */
    if ($Handle != NULL) {

      /* Acquire an exclusive lock on the file */
      $Check = flock ($Handle, LOCK_EX);

      /* Truncate the file to 0 bytes */
      if ($Check) {
        $Check = ftruncate ($Handle, 0);
      }

      /* Seek to the beginning of the file */
      if ($Check) {
        if ((fseek ($Handle, 0, SEEK_SET)) != 0) {
          $Check = FALSE;
        }
      }

      /* Write the content to the file */
      if ($Check) {
        if (!fputs ($Handle, $Content)) {
          $Check = FALSE;
        }
      }

      /* Close the file and release the lock */
      fclose ($Handle);
    }
    else {
      $Check = FALSE;
    }

    return $Check;
  }
?>
