<?php
  /*  Poster - Simple and light blog engine
   *  Copyright (C) 2004-2009  Andrea Bolognani <eof@kiyuko.org>
   *
   *  This program is free software; you can redistribute it and/or modify
   *  it under the terms of the GNU General Public License as published by
   *  the Free Software Foundation; either version 2 of the License, or
   *  (at your option) any later version.
   *
   *  This program is distributed in the hope that it will be useful,
   *  but WITHOUT ANY WARRANTY; without even the implied warranty of
   *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   *  GNU General Public License for more details.
   *
   *  You should have received a copy of the GNU General Public License along
   *  with this program; if not, write to the Free Software Foundation, Inc.,
   *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
   *
   *  Homepage: http://kiyuko.org/software/poster
   */

  function ParsePost ($PostId)
  {
    global $BlogRoot, $DataDir;

    $Post = NULL;

    /* Open the post file for input */
    $Handle = @fopen ($BlogRoot . $DataDir . $PostId . '/post', 'r');

    /* Check the file was opened correctly */
    if ($Handle != NULL) {

      /* Acquire a shared lock on the file */
      if (flock ($Handle, LOCK_SH)) {

        /* Create an empty post structure */
        $Post = array ('author'   => '',
                       'category' => '',
                       'title'    => '',
                       'body'     => '');

        /* Read one line from input file */
        while ($Line = fgets ($Handle)) {
          $Success = FALSE;

          /* Remove trailing newline */
          $Line = PurgeNewline ($Line);

          /* The line contains the login of the author */
          if (preg_match ('/^AUTHOR: (.*)$/', $Line)) {
            $Post['author'] = preg_replace ('/^AUTHOR: (.*)$/', '$1', $Line);
            $Success = TRUE;
          }

          /* The line contains the category of the post */
          if (preg_match ('/^CATEGORY: (.*)$/', $Line)) {
            $Post['category'] = preg_replace ('/^CATEGORY: (.*)$/', '$1', $Line);
            $Success = TRUE;
          }

          /* The line contains the title of the post */
          if (preg_match ('/^TITLE: (.*)$/', $Line)) {
            $Post['title'] = preg_replace ('/^TITLE: (.*)$/', '$1', $Line);
            $Success = TRUE;
          }

          /* The line is part of the body */
          if (!$Success) {
            $Post['body'] .= $Line . "\n";
          }
        }

        /* Strip trailing newline from post body */
        $Post['body'] = PurgeNewline ($Post['body']);
      }

      /* Close the file and release the lock */
      fclose ($Handle);
    }

    return $Post;
  }
?>
