<?php
  /*  Poster - Simple and light blog engine
   *  Copyright (C) 2004-2009  Andrea Bolognani <eof@kiyuko.org>
   *
   *  This program is free software; you can redistribute it and/or modify
   *  it under the terms of the GNU General Public License as published by
   *  the Free Software Foundation; either version 2 of the License, or
   *  (at your option) any later version.
   *
   *  This program is distributed in the hope that it will be useful,
   *  but WITHOUT ANY WARRANTY; without even the implied warranty of
   *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   *  GNU General Public License for more details.
   *
   *  You should have received a copy of the GNU General Public License along
   *  with this program; if not, write to the Free Software Foundation, Inc.,
   *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
   *
   *  Homepage: http://kiyuko.org/software/poster
   */

  function ParseTrackback ($PostId, $TrackbackId)
  {
    global $BlogRoot, $DataDir;

    $Trackback = NULL;

    /* Open the trackback file for input */
    $Handle = @fopen ($BlogRoot . $DataDir . $PostId . '/trackbacks/' .
                      $TrackbackId, 'r');

    /* Check the file was opened correctly */
    if ($Handle != NULL) {

      /* Acquire a shared lock on the file */
      if (flock ($Handle, LOCK_SH)) {

        /* Create an empty trackback */
        $Trackback = array ('url'       => '',
                            'title'     => '',
                            'blog_name' => '',
                            'excerpt'   => '');

        /* Read one line from input file */
        while ($Line = fgets ($Handle)) {
          $Success = FALSE;

          /* Remove trailing newline */
          $Line = PurgeNewline ($Line);

          /* The line contains the url of the related post */
          if (preg_match ('/^URL: (.*)$/', $Line)) {
            $Trackback['url'] = preg_replace ('/^URL: (.*)$/', '$1', $Line);
            $Success = TRUE;
          }

          /* The line contains the title of the related post */
          if (preg_match ('/^TITLE: (.*)$/', $Line)) {
            $Trackback['title'] = preg_replace ('/^TITLE: (.*)$/', '$1', $Line);
            $Success = TRUE;
          }

          /* The line contains the blog name */
          if (preg_match ('/^BLOG_NAME: (.*)$/', $Line)) {
            $Trackback['blog_name'] = preg_replace ('/^BLOG_NAME: (.*)$/', '$1', $Line);
            $Success = TRUE;
          }

          /* The line is part of the excerpt */
          if (!$Success) {
            $Trackback['excerpt'] .= $Line . "\n";
          }
        }

        /* Strip trailing newline from trackback excerpt */
        $Trackback['excerpt'] = PurgeNewline ($Trackback['excerpt']);
      }

      /* Close the file and release the lock */
      fclose ($Handle);
    }

    return $Trackback;
  }
?>
