<?php
  /*  Poster - Simple and light weight blog engine
   *  Copyright (C) 2004-2009  Andrea Bolognani <eof@kiyuko.org>
   *
   *  This program is free software; you can redistribute it and/or modify
   *  it under the terms of the GNU General Public License as published by
   *  the Free Software Foundation; either version 2 of the License, or
   *  (at your option) any later version.
   *
   *  This program is distributed in the hope that it will be useful,
   *  but WITHOUT ANY WARRANTY; without even the implied warranty of
   *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   *  GNU General Public License for more details.
   *
   *  You should have received a copy of the GNU General Public License along
   *  with this program; if not, write to the Free Software Foundation, Inc.,
   *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
   *
   *  Homepage: http://kiyuko.org/software/poster
   */

  /* Utility */
  require ($BlogRoot . 'include/purge_newline.php');
  require ($BlogRoot . 'include/is_number.php');
  require ($BlogRoot . 'include/random_string.php');

  /* Blog content */
  require ($BlogRoot . 'include/is_post.php');
  require ($BlogRoot . 'include/is_comment.php');
  require ($BlogRoot . 'include/is_trackback.php');
  require ($BlogRoot . 'include/read_users.php');
  require ($BlogRoot . 'include/read_categories.php');
  require ($BlogRoot . 'include/read_posts.php');
  require ($BlogRoot . 'include/read_comments.php');
  require ($BlogRoot . 'include/read_trackbacks.php');
  require ($BlogRoot . 'include/write_users.php');
  require ($BlogRoot . 'include/write_categories.php');
  require ($BlogRoot . 'include/get_context.php');
  require ($BlogRoot . 'include/get_query.php');
  require ($BlogRoot . 'include/get_posts_list.php');
  require ($BlogRoot . 'include/get_comments_number.php');
  require ($BlogRoot . 'include/get_trackbacks_number.php');
  require ($BlogRoot . 'include/comments_enabled.php');
  require ($BlogRoot . 'include/trackbacks_enabled.php');
  require ($BlogRoot . 'include/tags_replace.php');
  require ($BlogRoot . 'include/show_post.php');
  require ($BlogRoot . 'include/show_comments.php');
  require ($BlogRoot . 'include/show_trackbacks.php');
  require ($BlogRoot . 'include/show_comment_form.php');
  require ($BlogRoot . 'include/show_trackback_form.php');
  require ($BlogRoot . 'include/save_comment.php');
  require ($BlogRoot . 'include/save_trackback.php');
  require ($BlogRoot . 'include/send_ping.php');
  require ($BlogRoot . 'include/user_can.php');
  require ($BlogRoot . 'include/blog_archive.php');
  require ($BlogRoot . 'include/blog_categories.php');
  require ($BlogRoot . 'include/blog_authors.php');

  /* Parsers */
  require ($BlogRoot . 'include/parse_post.php');
  require ($BlogRoot . 'include/parse_comment.php');
  require ($BlogRoot . 'include/parse_trackback.php');

  /* Captcha filter */
  require ($BlogRoot . 'include/captcha_encrypt.php');
  require ($BlogRoot . 'include/captcha_decrypt.php');
  require ($BlogRoot . 'include/captcha_color_allocate.php');
  require ($BlogRoot . 'include/captcha_create_spiral.php');
  require ($BlogRoot . 'include/captcha_image.php');

  /* Blacklist filter */
  require ($BlogRoot . 'include/read_blacklist.php');
  require ($BlogRoot . 'include/write_blacklist.php');

  /* Miscellaneous stuff */
  require ($BlogRoot . 'include/time_offset_string.php');
  require ($BlogRoot . 'include/user_info.php');
  require ($BlogRoot . 'include/remove_future_posts.php');
  require ($BlogRoot . 'include/locked_file_write.php');
  require ($BlogRoot . 'include/create_blog_link.php');
?>
