<?php
  /*  Poster - Simple and light weight blog engine
   *  Copyright (C) 2004-2009  Andrea Bolognani <eof@kiyuko.org>
   *
   *  This program is free software; you can redistribute it and/or modify
   *  it under the terms of the GNU General Public License as published by
   *  the Free Software Foundation; either version 2 of the License, or
   *  (at your option) any later version.
   *
   *  This program is distributed in the hope that it will be useful,
   *  but WITHOUT ANY WARRANTY; without even the implied warranty of
   *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   *  GNU General Public License for more details.
   *
   *  You should have received a copy of the GNU General Public License along
   *  with this program; if not, write to the Free Software Foundation, Inc.,
   *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
   *
   *  Homepage: http://kiyuko.org/software/poster
   */

  function ReadCategories ()
  {
    global $BlogRoot;

    $Categories = array ();

    /* Open the categories file */
    $Handle = @fopen ($BlogRoot. 'categories', 'r');

    /* Check the file was opened correctly */
    if ($Handle != NULL) {

      /* Acquire a shared lock on the file */
     if (flock ($Handle, LOCK_SH)) {

        /* Read a line from the file */
        while ($Line = fgets ($Handle)) {

          /* Remove the trailing newline, we don't need it */
          $Line = PurgeNewline ($Line);

          /* Semi-random strings used to avoid splitting in the wring place */
          $Colon = '__COLON_' . RandomString (8) . '__';
          $Backslash = '__BACKSLASH_' . RandomString (8) . '__';

          /* Replace special chars with escaping strings */
          $Line = str_replace ('\\:', $Colon, $Line);
          $Line = str_replace ('\\\\', $Backslash, $Line);

          /* Split the line into tokens */
          $Fields = explode (':', $Line);

          /* Restore the special chars */
          for ($i = 0; $i < count ($Fields); $i++) {
            $Fields[$i] = str_replace ($Colon, ':', $Fields[$i]);
            $Fields[$i] = str_replace ($Backslash, '\\', $Fields[$i]);
          }

          list ($Short, $Long, $Users) = $Fields;

          /* Create the category and add it to the list */
          $Category = array ('long' => $Long,
                             'short' => $Short,
                             'users' => $Users);
          $Categories[$Short] = $Category;
        }
      }

      /* Close the file and release the lock */
      fclose ($Handle);
    }

    /* Add the default category 'General' if not present */
    if (!isset ($Categories['general'])) {
      $Category = array ('long' => 'General',
                         'short' => 'general',
                         'users' => '*');
      $Categories['general'] = $Category;
    }

    return $Categories;
  }
?>
