<?php
  /*  Poster - Simple and light weight blog engine
   *  Copyright (C) 2004-2009  Andrea Bolognani <eof@kiyuko.org>
   *
   *  This program is free software; you can redistribute it and/or modify
   *  it under the terms of the GNU General Public License as published by
   *  the Free Software Foundation; either version 2 of the License, or
   *  (at your option) any later version.
   *
   *  This program is distributed in the hope that it will be useful,
   *  but WITHOUT ANY WARRANTY; without even the implied warranty of
   *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   *  GNU General Public License for more details.
   *
   *  You should have received a copy of the GNU General Public License along
   *  with this program; if not, write to the Free Software Foundation, Inc.,
   *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
   *
   *  Homepage: http://kiyuko.org/software/poster
   */

  function ReadComments ()
  {
    global $BlogRoot, $DataDir, $CommentsOrder, $Posts;

    $Comments = array ();

    foreach ($Posts as $PostId) {

      /* Create an empty comment list */
      $PostComments = array ();

      /* Open the comment directory */
      $Content = opendir ($BlogRoot . $DataDir . $PostId . '/comments');

      while ($Item = readdir ($Content)) {

        /* Check the item is a comment */
        if (IsComment ($PostId, $Item)) {

          /* Add the comment to the list */
          $PostComments[] = $Item;
        }
      }

      /* Close the comment directory */
      closedir ($Content);

      /* Check there are comments before sorting */
      if (count ($PostComments) > 0) {

        /* Sort comments. Default order is Chronological */
        if (!strcmp ($CommentsOrder, 'Reverse')) {
          rsort ($PostComments);
        }
        else {
          sort ($PostComments);
        }
      }

      /* Add the post's id for reverse lookup */
      $PostComments['post_id'] = $PostId;
      $Comments[$PostId] = $PostComments;
    }

    return $Comments;
  }
?>
