<?php
  /*  Poster - Simple and light weight blog engine
   *  Copyright (C) 2004-2009  Andrea Bolognani <eof@kiyuko.org>
   *
   *  This program is free software; you can redistribute it and/or modify
   *  it under the terms of the GNU General Public License as published by
   *  the Free Software Foundation; either version 2 of the License, or
   *  (at your option) any later version.
   *
   *  This program is distributed in the hope that it will be useful,
   *  but WITHOUT ANY WARRANTY; without even the implied warranty of
   *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   *  GNU General Public License for more details.
   *
   *  You should have received a copy of the GNU General Public License along
   *  with this program; if not, write to the Free Software Foundation, Inc.,
   *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
   *
   *  Homepage: http://kiyuko.org/software/poster
   */

  function ReadTrackbacks ()
  {
    global $BlogRoot, $DataDir, $Posts, $TrackbacksOrder;

    $Trackbacks = array ();

    foreach ($Posts as $PostId) {

      /* Open the trackbacks directory  */
      $Content = opendir ($BlogRoot . $DataDir . $PostId . '/trackbacks');

      /* Create an empty list */
      $PostTrackbacks = array ();

      while ($Item = readdir ($Content)) {

        /* Check the item is a trackbacks */
        if (IsTrackBack ($PostId, $Item)) {

          /* Add the trackback to the list */
          $PostTrackbacks[] = $Item;
        }
      }

      /* Close the trackbacks directory */
      closedir ($Content);

      /* Check there are trackbacks before sorting */
      if (count ($PostTrackbacks) > 0) {

        /* Sort trackbacks. Default order is Chronological */
        if (!strcmp ($TrackbacksOrder, 'Reverse')) {
          rsort ($PostTrackbacks);
        }
        else {
          sort ($PostTrackbacks);
        }
      }

      /* Add the post's id for reverse lookup */
      $PostTrackbacks['post_id'] = $PostId;
      $Trackbacks[$PostId] = $PostTrackbacks;
    }

    return $Trackbacks;
  }
?>
