<?php
  /*  Poster - Simple and light weight blog engine
   *  Copyright (C) 2004-2009  Andrea Bolognani <eof@kiyuko.org>
   *
   *  This program is free software; you can redistribute it and/or modify
   *  it under the terms of the GNU General Public License as published by
   *  the Free Software Foundation; either version 2 of the License, or
   *  (at your option) any later version.
   *
   *  This program is distributed in the hope that it will be useful,
   *  but WITHOUT ANY WARRANTY; without even the implied warranty of
   *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   *  GNU General Public License for more details.
   *
   *  You should have received a copy of the GNU General Public License along
   *  with this program; if not, write to the Free Software Foundation, Inc.,
   *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
   *
   *  Homepage: http://kiyuko.org/software/poster
   */

  function ReadUsers ()
  {
    global $BlogRoot;

    $Users = array ();

    /* Open the users file */
    $Handle = @fopen ($BlogRoot . 'users', 'r');

    /* Check the file was opened correctly */
    if ($Handle != NULL) {

      /* Acquire a shared lock on the file */
      if (flock ($Handle, LOCK_SH)) {

        /* Read a line from the file */
        while ($Line = fgets ($Handle)) {

          /* Remove the trailing newline, we don't need it */
          $Line = PurgeNewline ($Line);

          /* Create semi-random strings to use in place of special chars */
          $Colon = '__COLON_' . RandomString (8) . '__';
          $Backslash = '__BACKSLASH_' . RandomString (8) . '__';

          /* Replace special chars */
          $Line = str_replace ('\\:', $Colon, $Line);
          $Line = str_replace ('\\\\', $Backslash, $Line);

          /* Get the tokens from the line */
          $Fields = explode (':', $Line);

          /* Restore the special chars */
          for ($i = 0; $i < count ($Fields); $i++) {
            $Fields[$i] = str_replace ($Colon, ':', $Fields[$i]);
            $Fields[$i] = str_replace ($Backslash, '\\', $Fields[$i]);
          }

          list ($Login, $Password, $Name, $Link, $Perms) = $Fields;

          /* Create a new user and add it to the list */
          $User = array ('name' => $Name,
                         'link' => $Link,
                         'login' => $Login,
                         'password' => $Password,
                         'perms' => $Perms);
          $Users[$Login] = $User;
        }
      }

      /* Close the file and release the lock */
      fclose ($Handle);
    }

    /* Add the default user 'anonymous' if not present */
    if (!isset ($Users['anonymous'])) {
      $User = array ('name' => 'anonymous',
                     'link' => '',
                     'login' => 'anonymous',
                     'password' => '*',
                     'perms' => '0000000');
      $Users['anonymous'] = $User;
    }

    return $Users;
  }
?>
