<?php
  /*  Poster - Simple and light weight blog engine
   *  Copyright (C) 2004-2009  Andrea Bolognani <eof@kiyuko.org>
   *
   *  This program is free software; you can redistribute it and/or modify
   *  it under the terms of the GNU General Public License as published by
   *  the Free Software Foundation; either version 2 of the License, or
   *  (at your option) any later version.
   *
   *  This program is distributed in the hope that it will be useful,
   *  but WITHOUT ANY WARRANTY; without even the implied warranty of
   *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   *  GNU General Public License for more details.
   *
   *  You should have received a copy of the GNU General Public License along
   *  with this program; if not, write to the Free Software Foundation, Inc.,
   *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
   *
   *  Homepage: http://kiyuko.org/software/poster
   */

  function SaveTrackback ($PostId)
  {
    global $BlogRoot, $BlogUrl, $DataDir;

    $Url = '';
    $Title = '';
    $BlogName = '';
    $Excerpt = '';
    $Check = TRUE;

    /* XML responses to use */
    $SuccessResponse = '<?xml version="1.0" encoding="utf-8"?' . '>
<response>
<error>0</error>
</response' . "\n";
    $ErrorResponse = '<?xml version="1.0" encoding="utf-8"?' . '>
<response>
<error>1</error>
</response' . "\n";

    /* Get trackback info from POST request */
    if (isset ($_POST['url'])) {
      $Url = stripslashes ($_POST['url']);
    }
    if (isset ($_POST['title'])) {
      $Title = stripslashes ($_POST['title']);
    }
    if (isset ($_POST['blog_name'])) {
      $BlogName = stripslashes ($_POST['blog_name']);
    }
    if (isset ($_POST['excerpt'])) {
      $Excerpt = stripslashes ($_POST['excerpt']);
    }

    /* Do nothing if trackbacks are disabled for this post */
    if (!TrackbacksEnabled ($PostId)) {

      if (!strcmp ($_SERVER['HTTP_REFERER'],
                   CreateBlogLink ('trackback=' . $PostId))) {
        $Check = FALSE;
      }
      else {
        echo $ErrorResponse;
        exit (1);
      }
    }

    /* If there is no trackback URL, just exit */
    if ($Check) {
      if (!strcmp ($Url, '')) {

        /* The tackback was generated using the form */
        if (!strcmp ($_SERVER['HTTP_REFERER'],
                     CreateBlogLink ('trackback=' . $PostId))) {
          $Check = FALSE;
        }

        /* The trackback comes from a blog */
        else {
          echo $ErrorResponse;
          exit (1);
        }
      }
    }

    /* Everything is fine, save the trackback */
    if ($Check) {

      /* Create timestamp */
      $Now = strtotime (TimeOffsetString (), time ());
      $TrackbackId = strftime ('%Y%m%d%H%M%S', $Now);

      /* Normalize excerpt */
      $Excerpt = str_replace ("\r\n", "\n", $Excerpt);
      $Excerpt = PurgeNewline ($Excerpt);

      /* Create file */
      $File = 'URL: ' . $Url .'
TITLE: ' . $Title . '
BLOG_NAME: ' . $BlogName . '
' . $Excerpt . "\n";

      /* Write trackback to file */
      $Check = LockedFileWrite ($BlogRoot . $DataDir . $PostId .
                                '/trackbacks/' . $TrackbackId, $File);

      /* Reply with a success message if the trackback came from a blog */
       if (strcmp ($_SERVER['HTTP_REFERER'],
                  CreateBlogLink ('trackback=' . $PostId))) {

        if ($Check) {

          echo $SuccessResponse;
          exit (0);
        }
        else {
          echo $ErrorResponse;
          exit (1);
	    }
      }
    }

    return $Check;
  }
?>
