<?php
  /*  Poster - Simple and light weight blog engine
   *  Copyright (C) 2004-2009  Andrea Bolognani <eof@kiyuko.org>
   *
   *  This program is free software; you can redistribute it and/or modify
   *  it under the terms of the GNU General Public License as published by
   *  the Free Software Foundation; either version 2 of the License, or
   *  (at your option) any later version.
   *
   *  This program is distributed in the hope that it will be useful,
   *  but WITHOUT ANY WARRANTY; without even the implied warranty of
   *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   *  GNU General Public License for more details.
   *
   *  You should have received a copy of the GNU General Public License along
   *  with this program; if not, write to the Free Software Foundation, Inc.,
   *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
   *
   *  Homepage: http://kiyuko.org/software/poster
   */

  function ShowCommentForm ($PostId)
  {
    global $BlogRoot, $BlogUrl, $TemplateDir;
    global $CaptchaFilter, $CaptchaSecretKey, $BlacklistFilter;

    $CaptchaImage = '';
    $CaptchaSecret = '';

    /* Create post permalink */
    $PostPermalink = CreateBlogLink ('comment=' . $PostId);
    $CommentFormAction = $PostPermalink;

    /* Check if the captcha filter is enabled */
    if (!strcmp ($CaptchaFilter, 'Enabled')) {

      /* Create a random string to be used for the captcha and encrypt it */
      $Secret = RandomString (mt_rand (6, 8));
      $Secret = CaptchaEncrypt ($Secret);

      $CaptchaImage = $BlogRoot . $TemplateDir . 'captcha_image.php?secret=' .
                      urlencode ($Secret);
      $CaptchaSecret = $Secret;
    }

    $V = array ('p.plink' => $PostPermalink,
                'f.action' => $CommentFormAction,
                'f.captcha_image' => $CaptchaImage,
                'f.captcha_secret' => $CaptchaSecret);

    /* Show form */
    ob_start ();
    include ($BlogRoot . $TemplateDir . 'comment_form.php');
    $CommentForm = ob_get_contents ();
    ob_end_clean ();
    echo TagsReplace ($CommentForm, $V);
  }
?>
