<?php
  /*  Poster - Simple and light weight blog engine
   *  Copyright (C) 2004-2009  Andrea Bolognani <eof@kiyuko.org>
   *
   *  This program is free software; you can redistribute it and/or modify
   *  it under the terms of the GNU General Public License as published by
   *  the Free Software Foundation; either version 2 of the License, or
   *  (at your option) any later version.
   *
   *  This program is distributed in the hope that it will be useful,
   *  but WITHOUT ANY WARRANTY; without even the implied warranty of
   *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   *  GNU General Public License for more details.
   *
   *  You should have received a copy of the GNU General Public License along
   *  with this program; if not, write to the Free Software Foundation, Inc.,
   *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
   *
   *  Homepage: http://kiyuko.org/software/poster
   */

  function ShowPost ($PostId)
  {
    global $BlogRoot, $TemplateDir, $Users, $Categories;

    /* Get the number of comments and trackbacks */
    $PostCommentsNumber = GetCommentsNumber ($PostId);
    $PostTrackbacksNumber = GetTrackbacksNumber ($PostId);

    /* The date/time of the post */
    $PostYear = substr ($PostId, 0, 4);
    $PostMonth = substr ($PostId, 4, 2);
    $PostDay = substr ($PostId, 6, 2);
    $PostHour = substr ($PostId, 8, 2);
    $PostMinute = substr ($PostId, 10, 2);
    $PostSecond = substr ($PostId, 12, 2);

    /* Get the post's content and meta informations */
    $Post = ParsePost ($PostId);

    /* Get info about the post's author */
    $Author = $Users[$Post['author']];
    $PostAuthorLogin = $Author['login'];
    $PostAuthorName = $Author['name'];
    $PostAuthorLink = $Author['link'];
    $PostAuthorPermalink = CreateBlogLink ('author=' . $Author['login']);

    /* Get the long name of the category (if it exists) for display purpose
     * and create the permalink to the category */
    $PostCategory = $Post['category'];
    $PostCategoryShort = $Categories[$PostCategory]['short'];
    if ($Categories[$PostCategory]['long']) {
      $PostCategory = $Categories[$PostCategory]['long'];
    }
    $PostCategoryPermalink = CreateBlogLink ('category=' . $Post['category']);

    /* Create various URLs related to this post */
    $PostPermalink = CreateBlogLink ('post=' . $PostId);
    $PostComments = CreateBlogLink ('comment=' . $PostId);
    $PostTrackbacks = CreateBlogLink ('trackback=' . $PostId);

    /* Get the content of the post */
    $PostTitle = $Post['title'];
    $PostBody = $Post['body'];

    /* Create the array used for tags replacing */
    $V = array ('p.id' => $PostId,
                'p.c_num' => $PostCommentsNumber,
                'p.t_num' => $PostTrackbacksNumber,
                'p.year' => $PostYear,
                'p.month' => $PostMonth,
                'p.day' => $PostDay,
                'p.hour' => $PostHour,
                'p.min' => $PostMinute,
                'p.sec' => $PostSecond,
                'p.a_name' => $PostAuthorName,
                'p.a_link' => $PostAuthorLink,
                'p.a_plink' => $PostAuthorPermalink,
                'p.cat' => $PostCategory,
                'p.cat_plink' => $PostCategoryPermalink,
                'p.plink' => $PostPermalink,
                'p.c' => $PostComments,
                'p.t' => $PostTrackbacks,
                'p.title' => $PostTitle,
                'p.body' => $PostBody);

    /* Show post */
    ob_start ();
    include ($BlogRoot . $TemplateDir . 'post.php');
    $Post = ob_get_contents ();
    ob_end_clean ();
    echo TagsReplace ($Post, $V);
  }
?>
