<?php
  /*  Poster - Simple and light weight blog engine
   *  Copyright (C) 2004-2009  Andrea Bolognani <eof@kiyuko.org>
   *
   *  This program is free software; you can redistribute it and/or modify
   *  it under the terms of the GNU General Public License as published by
   *  the Free Software Foundation; either version 2 of the License, or
   *  (at your option) any later version.
   *
   *  This program is distributed in the hope that it will be useful,
   *  but WITHOUT ANY WARRANTY; without even the implied warranty of
   *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   *  GNU General Public License for more details.
   *
   *  You should have received a copy of the GNU General Public License along
   *  with this program; if not, write to the Free Software Foundation, Inc.,
   *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
   *
   *  Homepage: http://kiyuko.org/software/poster
   */

  function ShowTrackbacks ($PostId)
  {
    global $BlogRoot, $TemplateDir, $Users, $Trackbacks;

    /* Get the list of all the trackbacks for this post */
    $PostTrackbacks = $Trackbacks[$PostId];
    unset ($PostTrackbacks['post_id']);

    /* Create post permalink */
    $PostPermalink = CreateBlogLink ('trackback=' . $PostId);

    /* This loop is repeated for each trackback */
    for ($i = 0; $i < count ($PostTrackbacks); $i++) {

      $TrackbackUrl = '';
      $TrackbackBlogName = '';
      $TrackbackTitle = '';
      $TrackbackExcerpt = '';

      $TrackbackId = $PostTrackbacks[$i];

      /* Date/time the trackback was recieved */
      $TrackbackYear = substr ($TrackbackId, 0, 4);
      $TrackbackMonth = substr ($TrackbackId, 4, 2);
      $TrackbackDay = substr ($TrackbackId, 6, 2);
      $TrackbackHour = substr ($TrackbackId, 8, 2);
      $TrackbackMinute = substr ($TrackbackId, 10, 2);
      $TrackbackSecond = substr ($TrackbackId, 12, 2);
      $TrackbackPermalink = $PostPermalink . '#_' . $TrackbackId;

      /* Parse trackback */
      $Trackback = ParseTrackback ($PostId, $TrackbackId);

      $TrackbackUrl = $Trackback['url'];
      $TrackbackBlogName = $Trackback['blog_name'];
      $TrackbackTitle = $Trackback['title'];
      $TrackbackExcerpt = $Trackback['excerpt'];

      /* Create the array used for tags replacing */
      $V = array ('p.id' => $PostId,
                  'p.plink' => $PostPermalink,
                  't.id' => $TrackbackId,
                  't.year' => $TrackbackYear,
                  't.month' => $TrackbackMonth,
                  't.day' => $TrackbackDay,
                  't.hour' => $TrackbackHour,
                  't.min' => $TrackbackMinute,
                  't.sec' => $TrackbackSecond,
                  't.plink' => $TrackbackPermalink,
                  't.url' => $TrackbackUrl,
                  't.b_name' => $TrackbackBlogName,
                  't.title' => $TrackbackTitle,
                  't.excerpt' => $TrackbackExcerpt);

      /* Show trackback */
      ob_start ();
      include ($BlogRoot . $TemplateDir . 'trackback.php');
      $Trackback = ob_get_contents ();
      ob_end_clean ();
      echo TagsReplace ($Trackback, $V);

      /* If there are other trackbacks, show a spacer */
      if ($i < (count ($PostTrackbacks) - 1)) {

        /* Show spacer */
        ob_start ();
        include ($BlogRoot . $TemplateDir . 'trackback-trackback_spacer.php');
        $Spacer = ob_get_contents ();
        ob_end_clean ();
        echo TagsReplace ($Spacer, NULL);
      }
    }
  }
?>
