<?php
  /*  Poster - Simple and light weight blog engine
   *  Copyright (C) 2004-2009  Andrea Bolognani <eof@kiyuko.org>
   *
   *  This program is free software; you can redistribute it and/or modify
   *  it under the terms of the GNU General Public License as published by
   *  the Free Software Foundation; either version 2 of the License, or
   *  (at your option) any later version.
   *
   *  This program is distributed in the hope that it will be useful,
   *  but WITHOUT ANY WARRANTY; without even the implied warranty of
   *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   *  GNU General Public License for more details.
   *
   *  You should have received a copy of the GNU General Public License along
   *  with this program; if not, write to the Free Software Foundation, Inc.,
   *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
   *
   *  Homepage: http://kiyuko.org/software/poster
   */

  function TagsReplace ($Code, $V)
  {
    global $BlogRoot, $TemplateDir, $UserName, $UserLink;
    global $BlogUrl, $BlogTitle, $BlogDescription, $BlogLanguage;
    global $PostsCount, $CommentsCount, $TrackbacksCount, $PagesCount;
    global $PreviousPage, $NextPage, $FirstPage, $LastPage;
    global $ModuleName, $PosterVersion, $CaptchaFilter;

    /* Global tags */
    $Code = str_replace ('<$BlogRoot$>', $BlogRoot, $Code);
    $Code = str_replace ('<$BlogUrl$>', $BlogUrl, $Code);
    $Code = str_replace ('<$BlogTitle$>', $BlogTitle, $Code);
    $Code = str_replace ('<$BlogDescription$>', $BlogDescription, $Code);
    $Code = str_replace ('<$BlogLanguage$>', $BlogLanguage, $Code);
    $Code = str_replace ('<$UserName$>', $UserName, $Code);
    $Code = str_replace ('<$UserLink$>', $UserLink, $Code);
    $Code = str_replace ('<$PostsCount$>', $PostsCount, $Code);
    $Code = str_replace ('<$CommentsCount$>', $CommentsCount, $Code);
    $Code = str_replace ('<$TrackbacksCount$>', $TrackbacksCount, $Code);
    $Code = str_replace ('<$PagesCount$>', $PagesCount, $Code);
    $Code = str_replace ('<$ModuleName$>', $ModuleName, $Code);
    $Code = str_replace ('<$PosterVersion$>', $PosterVersion, $Code);

    /* Check these tags are present in the template file before attempting
     * replace to avoid infinte loops */
    if (strstr ($Code, '<$BlogArchive$>')) {
      $BlogArchive = BlogArchive ();
      $Code = str_replace ('<$BlogArchive$>', $BlogArchive, $Code);
    }
    if (strstr ($Code, '<$BlogCategories$>')) {
      $BlogCategories = BlogCategories ();
      $Code = str_replace ('<$BlogCategories$>', $BlogCategories, $Code);
    }
    if (strstr ($Code, '<$BlogAuthors$>')) {
      $BlogAuthors = BlogAuthors ();
      $Code = str_replace ('<$BlogAuthors$>', $BlogAuthors, $Code);
    }

    /* Post tags */
    if (isset ($V['p.title'])) {
      $Code = str_replace ('<$PostTitle$>', $V['p.title'], $Code);
    }
    if (isset ($V['p.body'])) {
      $Code = str_replace ('<$PostBody$>', $V['p.body'], $Code);
    }
    if (isset ($V['p.cat'])) {
      $Code = str_replace ('<$PostCategory$>', $V['p.cat'], $Code);
    }
    if (isset ($V['p.cat_plink'])) {
      $Code = str_replace ('<$PostCategoryPermalink$>',$V['p.cat_plink'],$Code);
    }
    if (isset ($V['p.plink'])) {
      $Code = str_replace ('<$PostPermalink$>', $V['p.plink'], $Code);
    }
    if (isset ($V['p.c'])) {
      $Code = str_replace ('<$PostComments$>', $V['p.c'], $Code);
    }
    if (isset ($V['p.t'])) {
      $Code = str_replace ('<$PostTrackbacks$>', $V['p.t'], $Code);
    }
    if (isset ($V['p.a_name'])) {
      $Code = str_replace ('<$PostAuthorName$>', $V['p.a_name'], $Code);
    }
    if (isset ($V['p.a_link'])) {
      $Code = str_replace ('<$PostAuthorLink$>', $V['p.a_link'], $Code);
    }
    if (isset ($V['p.a_plink'])) {
      $Code = str_replace ('<$PostAuthorPermalink$>', $V['p.a_plink'], $Code);
    }
    if (isset ($V['p.year'])) {
      $Code = str_replace ('<$PostYear$>', $V['p.year'], $Code);
    }
    if (isset ($V['p.month'])) {
      $Code = str_replace ('<$PostMonth$>', $V['p.month'], $Code);
    }
    if (isset ($V['p.day'])) {
      $Code = str_replace ('<$PostDay$>', $V['p.day'], $Code);
    }
    if (isset ($V['p.hour'])) {
      $Code = str_replace ('<$PostHour$>', $V['p.hour'], $Code);
    }
    if (isset ($V['p.min'])) {
      $Code = str_replace ('<$PostMinute$>', $V['p.min'], $Code);
    }
    if (isset ($V['p.sec'])) {
      $Code = str_replace ('<$PostSecond$>', $V['p.sec'], $Code);
    }
    if (isset ($V['p.c_num'])) {
      $Code = str_replace ('<$PostCommentsNumber$>', $V['p.c_num'], $Code);
    }
    if (isset ($V['p.t_num'])) {
      $Code = str_replace ('<$PostTrackbacksNumber$>', $V['p.t_num'], $Code);
    }
    if (isset ($V['p.id'])) {
      $Code = str_replace ('<$PostId$>', $V['p.id'], $Code);
    }

    /* Comment tags */
    if (isset ($V['c.body'])) {
      $Code = str_replace ('<$CommentBody$>', $V['c.body'], $Code);
    }
    if (isset ($V['c.plink'])) {
      $Code = str_replace ('<$CommentPermalink$>', $V['c.plink'], $Code);
    }
    if (isset ($V['c.a_name'])) {
      $Code = str_replace ('<$CommentAuthorName$>', $V['c.a_name'], $Code);
    }
    if (isset ($V['c.a_link'])) {
      $Code = str_replace ('<$CommentAuthorLink$>', $V['c.a_link'], $Code);
    }
    if (isset ($V['c.a_plink'])) {
      $Code = str_replace ('<$CommentAuthorPermalink$>', $V['c.a_plink'],$Code);
    }
    if (isset ($V['c.id'])) {
      $Code = str_replace ('<$CommentId$>', $V['c.id'], $Code);
    }
    if (isset ($V['c.year'])) {
      $Code = str_replace ('<$CommentYear$>', $V['c.year'], $Code);
    }
    if (isset ($V['c.month'])) {
      $Code = str_replace ('<$CommentMonth$>', $V['c.month'], $Code);
    }
    if (isset ($V['c.day'])) {
      $Code = str_replace ('<$CommentDay$>', $V['c.day'], $Code);
    }
    if (isset ($V['c.hour'])) {
      $Code = str_replace ('<$CommentHour$>', $V['c.hour'], $Code);
    }
    if (isset ($V['c.min'])) {
      $Code = str_replace ('<$CommentMinute$>', $V['c.min'], $Code);
    }
    if (isset ($V['c.sec'])) {
      $Code = str_replace ('<$CommentSecond$>', $V['c.sec'], $Code);
    }

    /* Trackback tags */
    if (isset ($V['t.title'])) {
      $Code = str_replace ('<$TrackbackTitle$>', $V['t.title'], $Code);
    }
    if (isset ($V['t.excerpt'])) {
      $Code = str_replace ('<$TrackbackExcerpt$>', $V['t.excerpt'], $Code);
    }
    if (isset ($V['t.plink'])) {
      $Code = str_replace ('<$TrackbackPermalink$>', $V['t.plink'], $Code);
    }
    if (isset ($V['t.b_name'])) {
      $Code = str_replace ('<$TrackbackBlogName$>', $V['t.b_name'], $Code);
    }
    if (isset ($V['t.url'])) {
      $Code = str_replace ('<$TrackbackUrl$>', $V['t.url'], $Code);
    }
    if (isset ($V['t.id'])) {
      $Code = str_replace ('<$TrackbackId$>', $V['t.id'], $Code);
    }
    if (isset ($V['t.year'])) {
      $Code = str_replace ('<$TrackbackYear$>', $V['t.year'], $Code);
    }
    if (isset ($V['t.month'])) {
      $Code = str_replace ('<$TrackbackMonth$>', $V['t.month'], $Code);
    }
    if (isset ($V['t.day'])) {
      $Code = str_replace ('<$TrackbackDay$>', $V['t.day'], $Code);
    }
    if (isset ($V['t.hour'])) {
      $Code = str_replace ('<$TrackbackHour$>', $V['t.hour'], $Code);
    }
    if (isset ($V['t.min'])) {
      $Code = str_replace ('<$TrackbackMinute$>', $V['t.min'], $Code);
    }
    if (isset ($V['t.sec'])) {
      $Code = str_replace ('<$TrackbackSecond$>', $V['t.sec'], $Code);
    }

    /* Pager tags */
    $Code = str_replace ('<$PreviousPage$>', $PreviousPage, $Code);
    $Code = str_replace ('<$NextPage$>', $NextPage, $Code);
    $Code = str_replace ('<$FirstPage$>', $FirstPage, $Code);
    $Code = str_replace ('<$LastPage$>', $LastPage, $Code);

    /* Form tags */
    if (isset ($V['f.action'])) {
      $Code = str_replace ('<$CommentFormAction$>', $V['f.action'], $Code);
      $Code = str_replace ('<$TrackbackFormAction$>', $V['f.action'], $Code);
    }
    if (isset ($V['p.plink'])) {
      $Code = str_replace ('<$PostPermalink$>', $V['p.plink'], $Code);
    }

    /* Archive tags */
    if (isset ($V['a.year'])) {
      $Code = str_replace ('<$ArchiveYear$>', $V['a.year'], $Code);
    }
    if (isset ($V['a.month'])) {
      $Code = str_replace ('<$ArchiveMonth$>', $V['a.month'], $Code);
    }
    if (isset ($V['a.plink'])) {
      $Code = str_replace ('<$ArchivePermalink$>', $V['a.plink'], $Code);
    }
    if (isset ($V['a.p_num'])) {
      $Code = str_replace ('<$ArchivePostsNumber$>', $V['a.p_num'], $Code);
    }

    /* Categories tags */
    if (isset ($V['c.name'])) {
      $Code = str_replace ('<$CategoryName$>', $V['c.name'], $Code);
    }
    if (isset ($V['c.plink'])) {
      $Code = str_replace ('<$CategoryPermalink$>', $V['c.plink'], $Code);
    }
    if (isset ($V['c.p_num'])) {
      $Code = str_replace ('<$CategoryPostsNumber$>', $V['c.p_num'], $Code);
    }

    /* Authors tags */
    if (isset ($V['a.name'])) {
      $Code = str_replace ('<$AuthorName$>', $V['a.name'], $Code);
    }
    if (isset ($V['a.link'])) {
      $Code = str_replace ('<$AuthorLink$>', $V['a.link'], $Code);
    }
    if (isset ($V['a.plink'])) {
      $Code = str_replace ('<$AuthorPermalink$>', $V['a.plink'], $Code);
    }
    if (isset ($V['a.p_num'])) {
      $Code = str_replace ('<$AuthorPostsNumber$>', $V['a.p_num'], $Code);
    }

    /* Captcha filter tags */
    if (isset ($V['f.captcha_image'])) {
      $Code = str_replace ('<$CaptchaImage$>', $V['f.captcha_image'], $Code);
    }
    if (isset ($V['f.captcha_secret'])) {
      $Code = str_replace ('<$CaptchaSecret$>', $V['f.captcha_secret'], $Code);
    }

    /* Check the tag is used to prevent infinte loops */
    if (strstr ($Code, '<$CaptchaForm$>')) {

        /* Check the captcha filter is enabled */
        if (strcmp ($CaptchaFilter, 'Enabled') == 0) {

            /* Include the captcha form template */
            ob_start ();
            include ($BlogRoot . $TemplateDir . 'captcha_form.php');
            $Form = ob_get_contents ();
            ob_end_clean ();
            $Form = TagsReplace ($Form, $V);

            $Code = str_replace ('<$CaptchaForm$>', $Form, $Code);
        }

        /* If the captcha filter is not enabled, remove the tag */
        else {
            $Code = str_replace ('<$CaptchaForm$>', '', $Code);
        }
    }

    return $Code;
  }
?>
