<?php
  /*  Poster - Simple and light weight blog engine
   *  Copyright (C) 2004-2009  Andrea Bolognani <eof@kiyuko.org>
   *
   *  This program is free software; you can redistribute it and/or modify
   *  it under the terms of the GNU General Public License as published by
   *  the Free Software Foundation; either version 2 of the License, or
   *  (at your option) any later version.
   *
   *  This program is distributed in the hope that it will be useful,
   *  but WITHOUT ANY WARRANTY; without even the implied warranty of
   *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   *  GNU General Public License for more details.
   *
   *  You should have received a copy of the GNU General Public License along
   *  with this program; if not, write to the Free Software Foundation, Inc.,
   *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
   *
   *  Homepage: http://kiyuko.org/software/poster
   */

  function UserCan ($Action)
  {
    global $BlogUrl;

    $Result = FALSE;

    /* Get user's permissions from current session  */
    $Perms = $_SESSION[$BlogUrl]['perms'];

    /* Post-related permissions */
    if (!strcmp ($Action, 'create_post')) {
      $Perms = $Perms[0];
      if (($Perms == 4) || ($Perms == 5) || ($Perms == 6) || ($Perms == 7)) {
        $Result = TRUE;
      }
    }
    else if (!strcmp ($Action, 'edit_post')) {
      $Perms = $Perms[0];
      if (($Perms == 2) || ($Perms == 3) || ($Perms == 6) || ($Perms == 7)) {
        $Result = TRUE;
      }
    }
    else if (!strcmp ($Action, 'delete_post')) {
      $Perms = $Perms[0];
      if (($Perms == 1) || ($Perms == 3) || ($Perms == 5) || ($Perms == 7)) {
        $Result = TRUE;
      }
    }

    /* Comment-related permissions */
    else if (!strcmp ($Action, 'delete_comment')) {
      $Perms = $Perms[1];
      if (($Perms == 1) || ($Perms == 3) || ($Perms == 5) || ($Perms == 7)) {
        $Result = TRUE;
      }
    }


    /* Trackback-related permissions */
    else if (!strcmp ($Action, 'delete_trackback')) {
      $Perms = $Perms[2];
      if (($Perms == 1) || ($Perms == 3) || ($Perms == 5) || ($Perms == 7)) {
        $Result = TRUE;
      }
    }

    /* Category-related permissions */
    else if (!strcmp ($Action, 'create_category')) {
      $Perms = $Perms[3];
      if (($Perms == 4) || ($Perms == 5) || ($Perms == 6) || ($Perms == 7)) {
        $Result = TRUE;
      }
    }
    else if (!strcmp ($Action, 'edit_category')) {
      $Perms = $Perms[3];
      if (($Perms == 2) || ($Perms == 3) || ($Perms == 6) || ($Perms == 7)) {
        $Result = TRUE;
      }
    }
    else if (!strcmp ($Action, 'delete_category')) {
      $Perms = $Perms[3];
      if (($Perms == 1) || ($Perms == 3) || ($Perms == 5) || ($Perms == 7)) {
        $Result = TRUE;
      }
    }

    /* User-related permissions */
    else if (!strcmp ($Action, 'create_user')) {
      $Perms = $Perms[4];
      if (($Perms == 4) || ($Perms == 5) || ($Perms == 6) || ($Perms == 7)) {
        $Result = TRUE;
      }
    }
    else if (!strcmp ($Action, 'edit_user')) {
      $Perms = $Perms[4];
      if (($Perms == 2) || ($Perms == 3) || ($Perms == 6) || ($Perms == 7)) {
        $Result = TRUE;
      }
    }
    else if (!strcmp ($Action, 'delete_user')) {
      $Perms = $Perms[4];
      if (($Perms == 1) || ($Perms == 3) || ($Perms == 5) || ($Perms == 7)) {
        $Result = TRUE;
      }
    }

    /* Configuration-related permissions */
    else if (!strcmp ($Action, 'edit_configuration')) {
      $Perms = $Perms[6];
      if (($Perms == 2) || ($Perms == 3) || ($Perms == 6) || ($Perms == 7)) {
        $Result = TRUE;
      }
    }

    return $Result;
  }
?>
