<?php
  /*  Poster - Simple and light weight blog engine
   *  Copyright (C) 2004-2009  Andrea Bolognani <eof@kiyuko.org>
   *
   *  This program is free software; you can redistribute it and/or modify
   *  it under the terms of the GNU General Public License as published by
   *  the Free Software Foundation; either version 2 of the License, or
   *  (at your option) any later version.
   *
   *  This program is distributed in the hope that it will be useful,
   *  but WITHOUT ANY WARRANTY; without even the implied warranty of
   *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   *  GNU General Public License for more details.
   *
   *  You should have received a copy of the GNU General Public License along
   *  with this program; if not, write to the Free Software Foundation, Inc.,
   *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
   *
   *  Homepage: http://kiyuko.org/software/poster
   */

  ob_start ();

  $BlogRoot = '../';
  require ($BlogRoot . 'include/poster.php');

  echo '<?xml version="1.0" encoding="utf-8"?' . ">\n";
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
    <head>
        <title>Poster _ Setup</title>
        <meta http-equiv="content-type" content="text/html; charset=utf-8" />
        <link rel="stylesheet" type="text/css" href="setup.css" />
    </head>

    <body>

        <div id="header">
            <strong>Poster</strong> _ Setup
        </div>

        <hr class="hidden" />
        <div class="clear"></div>
<?php
  /* The user is submitting the form */
  if (!strcmp ($_SERVER['REQUEST_METHOD'], 'POST')) {

    /* Set umask to avoid strange permissions on files */
    umask (022);

    $BlogUrl = 'index.php';
    $DataDir = 'data/';
    $Login = '';
    $Name = '';
    $Link = 'http://';
    $Password = '';
    $Check = TRUE;
    $Error = '';

    /* Create a default config file, if it doesn't exist */
    if (!is_file ($BlogRoot . 'config.php')) {

      if (isset ($_POST['blog_url'])) {
        $BlogUrl = stripslashes ($_POST['blog_url']);
      }
      if (isset ($_POST['data_dir'])) {
        $DataDir = stripslashes ($_POST['data_dir']);
      }
	  if (isset ($_POST['time_offset'])) {
        $TimeOffset = stripslashes ($_POST['time_offset']);
      }

      /* Escape single quotes in user-provided data -- shouldn't be needed,
       * but you know, you're never paranoid enough ;) */
      $BlogUrl = str_replace ('\\', '\\\\', $BlogUrl);
      $BlogUrl = str_replace ('\'', '\\\'', $BlogUrl);
      $DataDir = str_replace ('\\', '\\\\', $DataDir);
      $DataDir = str_replace ('\'', '\\\'', $DataDir);
      $TimeOffset = str_replace ('\\', '\\\\', $TimeOffset);
      $TimeOffset = str_replace ('\'', '\\\'', $TimeOffset);

      $File = '<?php
  $BlogTitle = \'My blog\';
  $BlogDescription = \'A short description of my blog\';
  $BlogUrl = \'' . $BlogUrl . '\';
  $BlogLanguage = \'en\';
  $PostsNumber = 5;
  $PostsOrder = \'Reverse\';
  $CommentsOrder = \'Chronological\';
  $TrackbacksOrder = \'Chronological\';
  $CommentsDefault = \'Enabled\';
  $TrackbacksDefault = \'Enabled\';
  $BlacklistFilter = \'Disabled\';
  $CaptchaFilter = \'Disabled\';
  $CaptchaSecretKey = \'' . RandomString (20) . '\';
  $CaptchaBackgroundColor = \'#ffffff\';
  $CaptchaTextColor = \'#bab5b5\';
  $CaptchaSpiralColor = \'#abcdef\';
  $CaptchaOutlineColor = \'#000000\';
  $AllowedTags = \'<br>,<a>,<b>,<i>,<strong>,<em>,<img>,<span>\';
  $DataDir = \'' . $DataDir . '\';
  $TimeOffset = \'' . $TimeOffset . '\';
  $Debug = 0;
?' . ">\n";

      $Check = LockedFileWrite ($BlogRoot . 'config.php', $File);

      if ($Check) {
        $Check = chmod ($BlogRoot . 'config.php', 0644);

        if (!$Check) {
          $Error = 'Unable to set permissions on configuration file.';
        }
      }
      else {
        $Error = 'Unable to create configuration file.';
      }
    }

    /* Load configuration (from the old configuration file or from the
     * newly-created one, it doesn't matter) */
    if ($Check) {

      if (file_exists ($BlogRoot . 'config.php')) {
        require ($BlogRoot . 'config.php');
      }
      else {
        $Check = FALSE;
      }
    }

    if ($Check) {

      /* Create DataDir if it doesn't exist */
      if (!is_dir ($BlogRoot . $DataDir)) {
        $Check = mkdir ($BlogRoot . $DataDir, 0755);

        if (!$Check) {
          $Error = 'Unable to create data directory.';
        }
      }
    }

    if ($Check) {

      /* Create a default categories file, if it doesn't exist */
      if (!is_file ($BlogRoot . 'categories')) {
        $File = 'general:General:*' . "\n";

        $Check = LockedFileWrite ($BlogRoot . 'categories', $File);

        if ($Check) {
          $Check = chmod ($BlogRoot . 'categories', 0644);

          if (!$Check) {
            $Error = 'Unable to set permissions on categories file.';
          }
        }
        else {
          $Error = 'Unable to create categories file.';
        }
      }
    }

    if ($Check) {

      /* Create an empty blacklist file if it doesn't exist */
      if (!is_file ($BlogRoot . 'blacklist')) {

        $Check = LockedFileWrite ($BlogRoot . 'blacklist', "\n");

        if ($Check) {
          $Check = chmod ($BlogRoot . 'blacklist', 0644);

          if (!$Check) {
            $Error = 'Unable to set permissions on blacklist file.';
          }
        }
        else {
          $Error = 'Unable to create blacklist file.';
        }
      }
    }

    if ($Check) {

      /* Create the users file, unless a users file already exists */
      if (!file_exists ($BlogRoot . 'users')) {
      
        if (isset ($_POST['login'])) {
          $Login = stripslashes ($_POST['login']);
        }
        if (isset ($_POST['name'])) {
          $Name = stripslashes ($_POST['name']);
        }
        if (isset ($_POST['link'])) {
          $Link = stripslashes ($_POST['link']);
        }
        if ((isset ($_POST['password'])) && (isset ($_POST['confirm_password']))) {
          if (!strcmp ($_POST['password'], $_POST['confirm_password'])) {
            $Password = md5 (stripslashes ($_POST['password']));
          }
        }

        /* Check the password and the login are not empty */
        if ((strcmp ($Login, '')) && (strcmp ($Password, ''))) {

          /* Create an array containing all the fields */
          $File = array ($Login,
                         $Password,
                         $Name,
                         $Link,
                         '7117702');

          for ($i = 0; $i < count ($File); $i++) {

            /* Escape any special character*/
            $File[$i] = str_replace ('\\', '\\\\', $File[$i]);
            $File[$i] = str_replace (':', '\\:', $File[$i]);
          }

          /* Create the content of the file */
          $File = implode (':', $File) . "\n";

          /* Write the file to disk and give appropriate permissions */
          $Check = LockedFileWrite ($BlogRoot . 'users', $File);

          if ($Check) {
            $Check = chmod ($BlogRoot . 'users', 0644);

            if (!$Check) {
              $Error = 'Unable to set permissions on users file.';
            }
          }
          else {
            $Error = 'Unable to create users file.';
          }
        }

        else {
          $Check = FALSE;
          $Error = 'Empty login or password mismatch.';
        }
      }
    }

    if ($Check) {

      /* Create an authentication token for the user */
      session_name ('Poster');
      session_start ();

      $_SESSION[$BlogUrl] = array ('login'    => $Login,
                                   'password' => $Password,
                                   'perms'    => '7117702');

      session_write_close ();

    }

    echo '
        <div id="content_container">
            <div id="content">' . "\n";

    if ($Check) {
      echo '
                <p>The setup procedure is complete.</p>

                <p>You have already been logged in as the user you just
created. Now you can tweak the
<a href="../admin/configuration.php">configuration</a> or start
<a href="../admin/create.php?post">posting</a>. You may also want to read the
<a href="../documentation/index.html">documentation</a> before using Poster</p>

                <p><strong>Please delete the <code>setup/</code> directory and
its whole content as soon as possible. Leaving this directory online allows
anyone to take control of your blog, and edit/delete all your
data.</strong></p>' . "\n";
    }
    else {
      echo '
                <p>An error occurred during the setup procedure; the error
message is: <strong>' . $Error . '</strong></p>

                <p>Please correct the problem and run again the setup
script.</p>' . "\n";
    }

    echo '
            </div>
        </div>' . "\n";
  }

  /* Show the form */
  else {

    echo '
        <div id="help_container">
            <div id="help">' . "\n";
        
    /* Generate a random filename for the test file */
    $TestFile = 'poster_setup_test_file' . RandomString (8);

    /* Attempt to create the test file */
    $Handle = @fopen ($BlogRoot . $TestFile, 'w');

    /* The attempt failed */
    if ($Handle == NULL) {
      echo '
                <p><strong>The attempt to create a test file in the
installation directory failed. Please make sure the installation directory is
writable by <acronym title="PHP Hypertext Preprocessor">PHP</acronym> before
running the setup script. If unsure, <code>chmod</code> it
0777.</strong></p>' . "\n\n";
    }

    /* The file was succesfully created */
    else {

      /* Close and remove the file */
      fclose ($Handle);
      unlink ($BlogRoot . $TestFile);
    }

?>
                <p>This script will create some basic files and directories
required by Poster. It will also create the first user of your blog, so you
can log in and start posting.</p>

                <p>Please fill in the form on the left with all the needed
informations; the login must be a single, lower&ndash;word, while the name is
the one displayed and can contain any kind of character. The link is usually
the <acronym title="Uniform Resource Locator">URL</acronym> of the user's site
or main blog, but can also be any other kind of
<acronym title="Uniform Resource Locator">URL</acronym>.</p>

                <p>If the server you're installing Poster on isn't in the
same timezone you are, adjust the Time offset accordingly. Current time on
the server is <?php echo strftime ('%Y-%m-%d %H:%M:%S', time ()); ?>.</p>

                <p>You may want to read the
<a href="../documentation/index.html">documentation</a> before installing.</p>

            </div>
        </div>

        <hr class="hidden" />

        <div id="form_container">
            <div id="form">

<form method="post" action="index.php"><div>
<fieldset>
<legend><strong>Blog configuration</strong></legend>
<table style="width: 100%; border: 0">
<tr><td style="width: 30%">
<label for="blog_url">Blog <acronym title="Uniform Resource Locator">URL</acronym></label>
</td><td style="width: 70%">
<input type="text" id="blog_url" name="blog_url" value="index.php" style="width: 100%" />
</td></tr>
<tr><td style="width: 30%">
<label for="data_dir">Data directory</label>
</td><td style="width: 70%">
<input type="text" id="data_dir" name="data_dir" value="data/" style="width: 100%" />
</td></tr>
<tr><td style="width: 30%">
<label for="time_offset">Time offset</label>
</td><td style="width: 70%">
<input type="text" id="time_offset" name="time_offset" value="+0" style="width: 100%" />
</table>
</fieldset>

<fieldset>
<legend><strong>User info</strong></legend>
<table style="width: 100%; border: 0">
<tr><td style="width: 30%">
<label for="login">Login</label>
</td><td style="width: 70%">
<input type="text" id="login" name="login" style="width: 100%" />
</td></tr>
<tr><td style="width: 30%">
<label for="name">Name</label>
</td><td style="width: 70%">
<input type="text" id="name" name="name" style="width: 100%" />
</td></tr>
<tr><td style="width: 30%">
<label for="link">Link</label>
</td><td style="width: 70%">
<input type="text" id="link" name="link" value="http://" style="width: 100%" />
</td></tr>
<tr><td style="width: 30%">
<label for="password">Password</label>
</td><td style="width: 70%">
<input type="password" id="password" name="password" style="width: 100%" />
</td></tr>
<tr><td style="width: 30%">
<label for="confirm_password">Confirm password</label>
</td><td style="width: 70%">
<input type="password" id="confirm_password" name="confirm_password" style="width: 100%" />
</td></tr>
<tr><td style="width: 30%">
<input type="submit" value="Install" />
</td><td style="width: 70%">
&nbsp;
</td></td>
</table>
</fieldset>
</div></form>

            </div>
        </div>
<?php
  }
?>

        <hr class="hidden" />
        <div class="clear"></div>

        <div id="footer">
Setup | <a href="http://kiyuko.org/software/poster">Poster</a> 1.0.12
        </div>

    </body>
</html>

<?php
  ob_end_flush ();
?>
